<template>
  <Modal v-model="isShow" :close="closeModal">
    <div class="chuckConnectModal textDark">
      <h4 class="textDark">{{ modalTitle }}</h4>
      <p class="paragraphClass">
        ChucK es un nuevo lenguaje de programación<br />
        orientado a sonido, que permite generar, <br />
        grabar, sintetizar sonido en tiempo real.
      </p>
      <!-- SELECTOR OF SUPPORTED METHODS -->
      <div class="chuckConnectClass">
        <p class="paragraphClass">{{ modalDescription }}</p>
        <!-- Dos posibles modos para chuck [local, remoto] -->
        <!-- SELECCIONAR MODO CHUCK LOCAL -->
        <a
          v-show="connectChuckMethodSupport(ConnectChuckMethod.LOCAL)"
          :class="{
            aIconConnectMode: true,
            iModeShippingSelected:
              methodShippingSelected == ConnectChuckMethod.LOCAL,
          }"
          v-on:click="selectChuckLocalOrRemote(ConnectChuckMethod.LOCAL)"
          title="Dar clic aquí si desea activar chuck en este equipo."
        >
          <i>
            <font-awesome-icon :icon="['fas', 'tower-cell']" size="2x" />
          </i>
        </a>
        <!-- SELECCIONAR MODO CHUCK REMOTO -->
        <a
          v-show="connectChuckMethodSupport(ConnectChuckMethod.REMOTE)"
          :class="{
            aIconConnectMode: true,
            iModeShippingSelected:
              methodShippingSelected == ConnectChuckMethod.REMOTE,
          }"
          v-on:click="selectChuckLocalOrRemote(ConnectChuckMethod.REMOTE)"
          title="Dar clic aquí si desea conectarse a Chuck remotamente"
        >
          <i>
            <font-awesome-icon :icon="['fas', 'house-signal']" size="2x" />
          </i>
        </a>
        <!-- TODO: MODO USB NO SOPORTADO PARA CHUCK, PERO SÍ PARA PERIFÉRICOS -->
        <!-- <a -->
        <!--   v-show="connectChuckMethodSupport(ShippingMethod.USB)" -->
        <!--   :class="{ -->
        <!--     aIconConnectMode: true, -->
        <!--     iModeShippingSelected: methodShippingSelected == ShippingMethod.USB, -->
        <!--   }" -->
        <!--   v-on:click="selectChuckLocalOrRemote(ShippingMethod.USB)" -->
        <!-- > -->
        <!--   <i> -->
        <!--     <font-awesome-icon :icon="['fab', 'usb']" size="2x" /> -->
        <!--   </i> -->
        <!-- </a> -->
        <!-- END -->
      </div>
      <!-- IF CHUCK LOCAL METHOD IS SELECTED -->
      <div v-show="methodShippingSelected == ConnectChuckMethod.LOCAL">
        <p
          class="paragraphClass"
          title="Se ha seleccionado el modo de inicio de chuck en este equipo"
        >
          Modo seleccionado:
          <span class="spanSelected">Chuck local</span>
        </p>
        <p class="paragraphClass">Ip de éste equipo: {{ ipHostChuck }}</p>
        <div class="chuckConnectClass">
          <p
            class="paragraphClass"
            title="Dar clic en el ícono para iniciar Chuck"
          >
            {{ textChuckStatus }}
          </p>
          <div class="animate__animated animate__pulse animate__infinite">
            <a
              v-show="connectChuckMethodSupport(ConnectChuckMethod.LOCAL)"
              :class="{
                aIconConnectMode: true,
              }"
              v-on:click="switchChuck()"
              :style="{ color: iconColorChuckLocalStyle }"
              title="Dar clic aquí para iniciar o detener ChucK en este equipo"
            >
              <i>
                <font-awesome-icon :icon="iconChuckState" size="2x" />
              </i>
            </a>
          </div>
        </div>
      </div>
      <!-- IF CHUCK REMOTE METHOD IS SELECTED -->
      <div v-show="methodShippingSelected == ConnectChuckMethod.REMOTE">
        <p
          class="paragraphClass"
          title="En el modo chuck remoto se requiere otra computadora en red que tenga Chuck ejecutandose."
        >
          Modo seleccionado:
          <span class="spanSelected">Chuck remoto</span>
        </p>
        <div>
          <span>Conectarse a un servicio Chuck en Red</span>
        </div>
        <div class="chuckConnectClass">
          <div>
            <span>
              IP del servico de chuck configurado: {{ ipChuckRemoteLabel }}
            </span>
          </div>
          <div
            title="Debe poner la IP de otra computadora en la cual esté ejecutandose chuck"
          >
            <span>
              Seleccionar IP:
              <input placeholder="Editar IP" v-model="ipChuckRemoteEdit" />
            </span>
          </div>
          <span>
            Probar conexión:
            <a
              v-show="connectChuckMethodSupport(ConnectChuckMethod.REMOTE)"
              :class="{
                aIconConnectMode: true,
                iModeShippingSelected:
                  methodShippingSelected == ConnectChuckMethod.REMOTE,
              }"
              v-on:click="testConnectChuckRemote()"
            >
              <i>
                <font-awesome-icon
                  :icon="['fas', 'plug-circle-exclamation']"
                  size="2x"
                />
              </i>
            </a>
          </span>
        </div>
        <div>
          <span>¿No tiene una IP para conectarse?</span>
        </div>
        <div class="chuckConnectClass">
          <div style="text-align: center">
            <span>Escanear servicios de chuck en la red</span>
          </div>
          <div style="text-align: left">
            <span>
              <button v-on:click="stopScanConnect()">Detener scaner</button>
              <button v-on:click="initScanConnectChuckRemote()">
                Inicar scaner
              </button>
            </span>
          </div>
          <div>
            <span>Lista de servicios de chuck encontrados:</span>
            <li v-for="(item, index) in items" style="text-align: left">
              <button v-on:click="selectChuckRemoteFromIP(index)">
                Seleccionar ip:
              </button>
              {{ item }}
            </li>
          </div>
        </div>
      </div>
      <p></p>
      <p></p>
      <!-- CLOSE MODAL -->
      <button v-on:click="closeModal">Cerrar</button>
    </div>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, ref, watch, onMounted } from "vue";
import "animate.css"; // https://animate.style/
import {
  // -- LOG AND INFO --
  toastMsg,
  log,
  // -- CHUCK --
  ChuckStatus,
  connectChuckMethodSupport,
  ConnectChuckMethod,
  setConnectChuckMethodSelected,
  getConnectChuckMethodSelected,
  startChuck,
  getStatusChuck,
  killChuck,
  setOptionChuck,
  chuckConnectIP,
  checkChuckRemoteConection,
} from "../../../../host/index";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { library } from "@fortawesome/fontawesome-svg-core";
import {
  faTowerCell,
  faArrowLeft,
  faHouseSignal,
  faPlugCircleExclamation,
  faPlugCircleCheck,
  faPlug,
  faSave,
  faUndo,
  faRedo,
} from "@fortawesome/free-solid-svg-icons";
import { faUsb } from "@fortawesome/free-brands-svg-icons";
library.add(
  faTowerCell,
  faArrowLeft,
  faHouseSignal,
  faUsb,
  faPlugCircleExclamation,
  faPlugCircleCheck,
  faPlug,
  faSave,
  faUndo,
  faRedo
);

export default defineComponent({
  components: {
    "font-awesome-icon": FontAwesomeIcon,
  },
  props: ["trigger"],
  emits: ["closeConnecModal"],
  // emits: ["setFileProject"],
  setup(props, context) {
    const modalTitle = ref("ChucK =>");
    const modalDescription = ref("Seleccionar modo de inicio de Chuck:");
    const isShow = ref(false);
    const errorLoadFile = ref();
    const methodShippingSelected = ref(getConnectChuckMethodSelected());
    const ipHostChuck = ref();
    const ipChuckRemoteLabel = ref();
    const ipChuckRemoteEdit = ref();
    const items = ref();

    // Posibles íconos para el estado de conexión de chuck
    const IconChuckStateList: Array<Array<string>> = [];
    IconChuckStateList[ChuckStatus.LOCAL_CONNECT] = [
      "fas",
      "plug-circle-check",
    ];
    IconChuckStateList[ChuckStatus.DISCONNECT] = [
      "fas",
      "plug-circle-exclamation",
    ];
    const iconChuckState = ref();

    // Colores del ícono para los estados de conexión de chuck
    const iconColorChuckLocalStyleList: Array<string> = [];
    iconColorChuckLocalStyleList[ChuckStatus.DISCONNECT] = "yellow";
    iconColorChuckLocalStyleList[ChuckStatus.LOCAL_CONNECT] = "green";
    const iconColorChuckLocalStyle = ref();

    // Texto del estado
    const textChuckStatusList: Array<string> = [];
    textChuckStatusList[ChuckStatus.DISCONNECT] =
      "Dar clic en el icono para iniciar ChucK";
    textChuckStatusList[ChuckStatus.LOCAL_CONNECT] =
      "Dar clic en el ícono para detener ChucK";
    const textChuckStatus = ref();

    function selectChuckLocalOrRemote(method: ConnectChuckMethod) {
      setConnectChuckMethodSelected(method);
      methodShippingSelected.value = getConnectChuckMethodSelected();
    }

    function showModal() {
      isShow.value = true;
    }

    function closeModal() {
      isShow.value = false;
      context.emit("closeConnecModal");
    }

    function selectChuckRemoteFromIP(ip: number) {
      ipChuckRemoteEdit.value = items.value[ip];
      testConnectChuckRemote();
    }

    function stopScanConnect() {
      chuckConnectIP.setCountSearchChuckIP(256);
    }

    const connectChuck = async () => {
      toastMsg({
        data: "Iniciando chuck!",
        type: "info",
      });
      setOptionChuck(["--port:2215"]);
      await startChuck();
    };

    const disconnectChuck = async () => {
      setOptionChuck(["--port:2215"]);
      const ret = await killChuck();
      toastMsg({
        data: ret == 0 ? "Chuck apagado" : "No fue posible apagar chuck",
        type: ret == 0 ? "info" : "error",
      });
    };

    const switchChuck = () => {
      if (getStatusChuck() == ChuckStatus.LOCAL_CONNECT) {
        disconnectChuck();
        iconChuckState.value = IconChuckStateList[ChuckStatus.DISCONNECT];
        iconColorChuckLocalStyle.value =
          iconColorChuckLocalStyleList[ChuckStatus.DISCONNECT];
        textChuckStatus.value = textChuckStatusList[ChuckStatus.DISCONNECT];
      } else {
        connectChuck();
        iconChuckState.value = IconChuckStateList[ChuckStatus.LOCAL_CONNECT];
        iconColorChuckLocalStyle.value =
          iconColorChuckLocalStyleList[ChuckStatus.LOCAL_CONNECT];
        textChuckStatus.value = textChuckStatusList[ChuckStatus.LOCAL_CONNECT];
      }
    };

    async function initScanConnectChuckRemote() {
      if (getStatusChuck() == ChuckStatus.LOCAL_CONNECT) {
        await disconnectChuck();
      }
      items.value = [];
      toastMsg({
        data: "Iniciando proceso de escaner de dispositivos",
        time: 4000,
      });
      chuckConnectIP.setIpHost();
      await chuckConnectIP.scanChuckServiceByIp();
      items.value = chuckConnectIP.getValidadeChuckIpList();
      toastMsg({
        data: "Proceso terminado",
      });
    }

    async function testConnectChuckRemote() {
      /* Verificar que chuck local esté desactivado para iniciar
       * configuración de chuck remoto.
       */
      if (getStatusChuck() == ChuckStatus.LOCAL_CONNECT) {
        await disconnectChuck();
      }
      if (await checkChuckRemoteConection(ipChuckRemoteEdit.value)) {
        chuckConnectIP.setIpChuckRemote(ipChuckRemoteEdit.value);
        ipChuckRemoteLabel.value = chuckConnectIP.getIpChuckRemote();
        toastMsg({
          data:
            "Se ha configurado chuck remotamente en la ip" +
            ipChuckRemoteEdit.value,
          time: 4000,
          type: "success",
        });
      } else {
        toastMsg({
          data:
            "No se encontró un servicio de chuck corriendo en la ip" +
            ipChuckRemoteEdit.value,
          type: "error",
        });
      }
    }

    watch(
      () => props.trigger,
      (msg, oldMsg) => {
        console.log(
          "watch: ",
          "trigger value actual: ",
          msg,
          "\ntrigger value old: ",
          oldMsg,
          "\nthis message: "
        );
        if (msg) {
          showModal();
        } else {
          closeModal();
        }
        chuckConnectIP.setIpHost();
        ipHostChuck.value = chuckConnectIP.getIpHost();
        ipChuckRemoteLabel.value = chuckConnectIP.getIpChuckRemote();
        ipChuckRemoteEdit.value =
          chuckConnectIP.getIpChuckRemote() != ""
            ? chuckConnectIP.getIpChuckRemote()
            : "";
      }
    );

    onMounted(() => {
      if (getStatusChuck() == ChuckStatus.LOCAL_CONNECT) {
        iconChuckState.value = IconChuckStateList[ChuckStatus.LOCAL_CONNECT];
        iconColorChuckLocalStyle.value =
          iconColorChuckLocalStyleList[ChuckStatus.LOCAL_CONNECT];
        textChuckStatus.value = textChuckStatusList[ChuckStatus.LOCAL_CONNECT];
      } else {
        iconChuckState.value = IconChuckStateList[ChuckStatus.DISCONNECT];
        iconColorChuckLocalStyle.value =
          iconColorChuckLocalStyleList[ChuckStatus.DISCONNECT];
        textChuckStatus.value = textChuckStatusList[ChuckStatus.DISCONNECT];
      }
    });

    return {
      //-- vars template --
      errorLoadFile,
      modalTitle,
      modalDescription,
      methodShippingSelected,
      ipChuckRemoteLabel,
      ipHostChuck,
      ipChuckRemoteEdit,
      items,
      iconColorChuckLocalStyle,
      textChuckStatus,
      // -- vars icon
      iconChuckState,
      // -- objects
      // -- enums
      ConnectChuckMethod,
      //-- METHODS --
      connectChuckMethodSupport,
      selectChuckLocalOrRemote,
      testConnectChuckRemote,
      initScanConnectChuckRemote,
      stopScanConnect,
      selectChuckRemoteFromIP,
      switchChuck,
      getStatusChuck,
      //-- vars modal --
      isShow,
      showModal,
      closeModal,
    };
  },
});
</script>

<style>
.paragraphClass {
  margin: 15px;
}
.chuckConnectClass {
  padding: 5px;
  background-color: #131516;
}
.chuckConnectModal {
  width: auto;
  height: 60%;
  /* width: 300px;*/
  padding: 10px;
  box-sizing: border-box;
  background-color: #333;
  font-size: 20px;
  text-align: center;
  position: relative; /* [absolute, relative] */
  top: 20px;
  bottom: 30px;
  overflow: auto; /* [scroll, auto] */
}
.aIconConnectMode {
  padding-left: 15px;
  padding-right: 15px;
  color: white;
}
.aIconConnectMode:hover {
  color: yellow;
  cursor: pointer;
}
.iModeShippingSelected {
  color: green !important;
}
.spanSelected {
  color: green;
}
.textDark {
  color: white;
}
.classMessage {
  height: auto;
  text-align: left;
  white-space: pre; /* habilita \n y \t para <p> */
}
.vue-universal-modal {
  z-index: 71;
}
</style>
